require("readxl")

########################################################
########################################################
## Purpose: get the initial estimates for the different models
## in the paper.
##
## INPUTS:
## model 1: static, 2: macro frailty, 3: macro frailty also in credits,
##    4: as before, but also credit frailty, 5: only covariate in credits,
##    6: as model 5, but plus credit frailty
##    61: as 6, but with IP billions. 62: as 6, but with IP+subs billions.
## precovid: if TRUE, estimates on pre-covid period

get_paper_parameter <- function(model, precovid = FALSE) {
  
  #if (model == 4) {
  #  init_par <- c(0.0332536720751718,-1.5921895106467,3.25081891061761,2.66464487937284,0.139543984392988,3.56205779909216,-6.62210570356465,5.95622590431534,1.57158048649844,2.53225247249947,-0.0122848532919682,-0.0634573384644709,1.06324021647383)
  #} else {
  #  stop(paste("Error: this model is not in the initial parameter set"))
  #}
  
  data_map <- "../../../Results/"
  
  if(precovid){
    folder <- "Pre-covid-macro-annual/"
  }
  if(!precovid){
    folder <- "All-data-macro-annual/"
  }
  mod <- toString(model)
  path <- paste0(data_map,folder,"Model ",mod, "/results.xlsx", sep = "")
  file <- readxl::read_xlsx(path)
  init_par <- file[1:2,]  
}




