########################################################
########################################################
## Purpose: intermediate plotting of fit during MLE
plot_data <- function(data, filter) {
  stdz <- function(series) return((series - mean(series, na.rm = TRUE))/(sd(series, na.rm = TRUE) + (sd(series, na.rm = TRUE)==0)))
  ## if covariates not defined, put them to zero
  if (is.null(filter$zmatM)) filter$zmatM <- 0
  if (is.null(filter$zmatR.2)) filter$zmatR.2 <- matrix(0, ncol = 2)
  ## plot the result
  par(mfrow = c(1,2))
  if (is.null(data$fM.true)) {
    plot(data$date, filter$fM + filter$zmatM, ylab = "Macro", col = "blue", type = "l")
    lines(data$date, data$yM, col = "red")
  } else {
    plot(data$date, data$fM.true, ylab = "True f, fhat", col = "red", type = "l")
    lines(data$date, filter$fM, col = "blue")
  }
  if (is.null(data$fR.true)) {
    emp <- data$yR[ , 2, 3] / rowSums(data$yR[ , 2, ])
    fit_emp <- filter$NP_D
    if (exists("GLOBAL_12M_PD_SMOOTHING")) if (GLOBAL_12M_PD_SMOOTHING) {
      emp <- c(emp[1:11], rollmean(emp, 12))
      fit_emp <- c(fit_emp[1:11], rollmean(fit_emp, 12))
    }
    plot(data$date, emp, ylab = "NP.D", col = "red", type = "l")
    lines(data$date, fit_emp, col = "blue", type = "l")
  } else {
    plot(data$date, data$fR.true, col = "red", type = "l")
    lines(data$date, filter$fR.2, col = "blue")
  }
  par(mfrow = c(1,1))
}
