print("**************************************")
print("**************************************")
print("** THIS CODE DOES NOT WORK DUE TO   **")
print("** DATA LICENSE RESTRICTIONS BUT IS **")
print("** PROVIDED AS BACKGROUND REFERENCE **")
print("**************************************")
print("**************************************")
stop(0)

# set rating scales choice out of 2, 7, 21
nr_rating_scales <- 21

# read the raw data
## based on Entity ratings, Credit Watch Date
ratingdata <- read.csv("../../data/raw_ratings_data_CREDITWATCHDATA_20211202.csv")
outputfilename <- paste0("../../data/transitions_", nr_rating_scales, "scale_CrWatchDate.csv")
## based on Entity ratings, Rating Date
# ratingdata <- read.csv("../../data/raw_ratings_data_RATINGDATA_20211202.csv")
# outputfilename <- paste0("../../data/transitions_", nr_rating_scales, "scale_RatingDate.csv")

# last full month; stop processing after this date
last_available_date <- as.Date("2021-10-01")

# cast dates to dates
ratingdata$ratingdate <- as.Date(as.character(ratingdata$ratingdate), "%Y%m%d")

# subselect cases
print(nrow(ratingdata))
ratingdata <- subset(ratingdata, countrycode == "USA")
print(nrow(ratingdata))
ratingdata <- subset(ratingdata, ratingtypecode == "STDLONG")
print(nrow(ratingdata))
ratingdata <- subset(ratingdata, sectorcode == "CORPS", select = c("entity_id", "ratingdate", "ratingsymbol", "entname") )
print(nrow(ratingdata))
ratingdata <- unique(ratingdata)
print(nrow(ratingdata))
ratingdata <- subset(ratingdata, ratingdate <= last_available_date)
print(nrow(ratingdata))


# set the buckets
if (nr_rating_scales == 2) {
  categories <- list(
    IG = c("AAA", "AA+", "AA", "AA-", "A+", "A", "A-", "BBB+", "BBB", "BBB-"),
    NP = c("BB+", "BB", "BB-", "B+", "B", "B-", "CCC+", "CCC", "CCC-", "CC", "C"),
    D  = c("D", "SD"),
    NR = "NR"
  )
} else if (nr_rating_scales == 7) {
  categories <- list(
    AAA = "AAA", AA = c("AA+", "AA", "AA-"), A = c("A+", "A", "A-"),
    BBB = c("BBB+", "BBB", "BBB-"), BB = c("BB+", "BB", "BB-"), B = c("B+", "B", "B-"), 
    CCC = c("CCC+", "CCC", "CCC-", "CC", "C"),
    D = c("D", "SD"),
    NR = "NR"
  )
} else if (nr_rating_scales == 21) {
  categories <- list(
    AAA = "AAA", AAp = "AA+", AA = "AA", AAm = "AA-", Ap = "A+", A = "A", Am = "A-",
    BBBp = "BBB+", BBB = "BBB", BBBm = "BBB-", BBp = "BB+", BB = "BB", BBm = "BB-",
    Bp = "B+", B = "B", Bm = "B-", CCCp = "CCC+", CCC = "CCC", CCCm = "CCC-",
    CC = "CC", C = "C", 
    D = c("D", "SD"),
    NR = "NR"
  )
}
nr_categories <- length(categories)
which_categories <- names(categories)
for (i1 in 1:nr_categories) {
  ratingdata$ratingsymbol[ which(ratingdata$ratingsymbol %in% categories[[i1]]) ] <- which_categories[i1]
}
ratingdata$ratingsymbol <- factor(ratingdata$ratingsymbol)


# get the companies
companies <- data.frame( ID = unique(ratingdata$entity_id))
companies$rating_in <- "NR"
companies$rating_in <- factor(companies$rating_in, levels = which_categories)
companies$rating_out <- companies$rating_in
rownames(companies) <- companies$ID

# loop over dates
counts <- rbind(data.frame(), rep(NA, 1 + nr_categories * (nr_categories + 1)))
prevdate <- as.Date("1900-1-1", "%Y-%m-%d")
counts[1,1] <- prevdate
counts[ , 1] <- as.Date("1900-1-1", "%Y-%m-%d")
current_count_row <- 2
for (yr in 1930:2021) {
  for (mnth in 1:12) {
    
    # cut out the data for this subperiod
    if (prevdate > last_available_date) break
    thisdate <- as.Date(paste0(yr,"-",mnth,"-",1), "%Y-%m-%d")
    mydata <- subset(ratingdata, (ratingdate >= prevdate) & (ratingdate < thisdate))
    
    # update the ratings
    if (nrow(mydata) > 0) {
      # update new ratings
      # loop over IDs to integrate multiple rating changes in period into one
      for (this_ID in as.character(unique(mydata$entity_id))) {
        submydata <- subset(mydata, entity_id == this_ID)
        submydata <- submydata[ order(submydata$ratingdate), ]
        companies[this_ID, "rating_out"] <- submydata$ratingsymbol[nrow(submydata)]
      }
    }

    # store counts of starting ratings
    start_ratings <- table(companies$rating_in)[ which_categories ]
    # store counts of transitions
    transitions <- table(companies[ , c("rating_in", "rating_out")])[ which_categories, which_categories]
    # put into the dataframe
    counts[current_count_row, 2:ncol(counts)] <-  c(start_ratings, c(t(transitions)))
    # put date into dataframe
    counts[current_count_row, 1] <- prevdate
    
    # update counters
    prevdate <- thisdate
    companies$rating_in <- companies$rating_out
    current_count_row <- current_count_row + 1
  }
}


# drop first dummy row, re-type counts, label columns, save
counts <- counts[2:nrow(counts), ]
counts_colnames <- c("Mth.Year", which_categories)
for (i1 in 1:nr_categories) {
  counts_colnames <- c(counts_colnames, paste(which_categories[i1], which_categories, sep = "."))
}
colnames(counts) <- counts_colnames
counts[ , 1] <- as.Date(counts[ , 1], "%d-%m-%Y")
write.csv(counts, outputfilename)