## number of months to simulate
x <- read.csv("Ratings_empty.csv")
x$X <- NULL
x$Mth.Year <- as.Date(x$Mth.Year, "%d/%m/%Y")
iT <- nrow(x)

## transition matrices in 2 rating system
vWave <- 0.5 * sin(2 * pi * (1:iT) * 7 / iT)
cPi <- array(0, dim = c(iT,2,3))
cPi[ , 1, 3] <- pnorm(-3 + vWave)
cPi[ , 1, 2] <- pnorm(-2 + vWave) - cPi[ , 1, 1]
cPi[ , 1, 1] <- 1 - cPi[ , 1, 1] - cPi[ , 1, 2]
cPi[ , 2, 3] <- pnorm(-2 + vWave)
cPi[ , 2, 1] <- pnorm(2 + vWave, lower.tail = FALSE)
cPi[ , 2, 2] <- 1 - cPi[ , 2, 1] - cPi[ , 2, 3]


## initialize data and exposures
mExposures <- matrix(25 + rbinom(iT * 2, 100, 0.5), nrow = iT, ncol = 2)

for (i1 in 1:iT) {
  for (i2 in 1:2) {
      x[i1, 1 + i2] <- mExposures[i1, i2]
      x[i1, 5 + (1:3) + (i2-1)*4] <- 
        rmultinom(1, mExposures[i1, i2], cPi[i1, i2, ])
  }
}

write.csv(x, file = "transitions_2scale_RatingDate.csv", row.names = FALSE)
